/*                          ======  NM-Base.c  ====== 
 *
 * void Renew_Bar_Num()
 * void Swap_Notes(Mdy_Id,P,Nt_1,Nt_2,At_high)
 * int  Re_Order_Notes(Mdy_Id,P,New_Note,Add,nx,ny,At_high)
 * void Draw_Note(nx,ny,z,x,y,five,Num,Upward,At_high)
 * void Display_Note(Melody_Id,P,Z,X,Step,At_high)
 * void Show_Word(Word_Id,Page)
 * void Show_Piano(x,y,button)
 * int  Piano_Note(px,py,mx,my)
 * void Move_Word(From_kind,From_num,To_kind,To_num)
 * void Move_Melody(From_kind,From_num,To_kind,To_num)
 * void Switch_Melody(From_kind,To_kind)
 * void Play()
 * void Sing(q)
 * void Dance()
 * int  Count(k,ad_pg,n,At_high)
 * void Showpage(k,PG,P_PG,dum,Num_A,Num_Z)
 * void Save_To_Midi(filename,k)
 * int  Load_From_Midi(filename,k)
 * void Save_To_Back_Up(filename,k)
 * int  Load_From_Back_Up(filename,k,Single)
 * void Show_host(IN)
 * void Finish_host()
 * void Update_Text_Tar()
 *
 */

#include "NM.h"

XImage *pt0,*pt1,*pt2,*pic[2][33],*ptdcr;

void Renew_Bar_Num()
{
  Use_Font("7x14");Rub(895,760,22,15,"RoyalBlue");
  SetColor("green");Out_I_XY(895,773,M_Bar_Num);
}

void Swap_Notes(Mdy_Id,P,Nt_1,Nt_2,At_high)
  int Mdy_Id,P,Nt_1,Nt_2,At_high;
{
  int Buf;

  Buf=St[Mdy_Id][P][At_high].nt[Nt_1];
  St[Mdy_Id][P][At_high].nt[Nt_1]=St[Mdy_Id][P][At_high].nt[Nt_2];
  St[Mdy_Id][P][At_high].nt[Nt_2]=Buf;
}

int Re_Order_Notes(Mdy_Id,P,New_Note,Add,Nx,Ny,At_high)
  int Mdy_Id,P,New_Note,Add,Nx,Ny,At_high;
{
  int i,k,num,Mid;

  if (At_high==0) Mid=50;else Mid=71;

  if (Add==1)
    {
      num=0;
      for (i=0;i<4;i++) 
	{
	  if (0<St[Mdy_Id][P][At_high].nt[i] && 
	      St[Mdy_Id][P][At_high].nt[i]<600) num++;
	  if (St[Mdy_Id][P][At_high].nt[i]==New_Note )
	    { 
	      if (Nx==15) St[Mdy_Id][P][At_high].nt[i]+=1-2*Ny;
	      if (Nx==18) St[Mdy_Id][P][At_high].nt[i]+=200;
	      return 1;
	    }
	  if(num==4) return -1;
	}
      
      switch (num)
	{
	  case 0:St[Mdy_Id][P][At_high].nt[0]=New_Note;
	         St[Mdy_Id][P][At_high].act=8;
	    break;
	  case 1:St[Mdy_Id][P][At_high].nt[1]=New_Note;
		 if ((New_Note+St[Mdy_Id][P][At_high].nt[0])/2>=Mid)
		   {                                         /* Downward */
		     if (New_Note<St[Mdy_Id][P][At_high].nt[0])
		       Swap_Notes(Mdy_Id,P,0,1,At_high);
		   }
		 else                                        /*  Upward  */
		   {
		     if (New_Note>St[Mdy_Id][P][At_high].nt[0])
		       Swap_Notes(Mdy_Id,P,0,1,At_high);
		   }
	    break;
	  case 2:St[Mdy_Id][P][At_high].nt[2]=New_Note;
		 if ((New_Note+St[Mdy_Id][P][At_high].nt[0]+
		      St[Mdy_Id][P][At_high].nt[1])/3>=Mid)   /* Downward */
		   {
		     for (k=2;k>0;k--)
		       if (St[Mdy_Id][P][At_high].nt[k]<
			   St[Mdy_Id][P][At_high].nt[k-1])
			 Swap_Notes(Mdy_Id,P,k,k-1,At_high);
		   }
		 else                                        /*  Upward  */
		   {
		     for (k=2;k>0;k--)
		       if (St[Mdy_Id][P][At_high].nt[k]>
			   St[Mdy_Id][P][At_high].nt[k-1])
			 Swap_Notes(Mdy_Id,P,k,k-1,At_high);
		   }
	    break;
	  case 3:St[Mdy_Id][P][At_high].nt[3]=New_Note;
		 if ((New_Note+St[Mdy_Id][P][At_high].nt[0]+
		      St[Mdy_Id][P][At_high].nt[1]+
		      St[Mdy_Id][P][At_high].nt[2])/4>=Mid)    /* Downward */
		   {
		     for (k=3;k>0;k--)
		       if (St[Mdy_Id][P][At_high].nt[k]<
			   St[Mdy_Id][P][At_high].nt[k-1])
			 Swap_Notes(Mdy_Id,P,k,k-1,At_high);
		   }
		 else                                        /*  Upward  */
		   {
		     for (k=3;k>0;k--)
		       if (St[Mdy_Id][P][At_high].nt[k]>
			   St[Mdy_Id][P][At_high].nt[k-1])
			 Swap_Notes(Mdy_Id,P,k,k-1,At_high);
		   }
	    break;
	  }
      return 1;
    }
  else if (Add==0)
         {
	   num=-1;
	   for (i=0;i<4;i++) if (St[Mdy_Id][P][At_high].nt[i]==New_Note) num=i;
	   if (num==-1) return -1;

	   switch (num)
	     {
	       case 0:St[Mdy_Id][P][At_high].nt[0]=St[Mdy_Id][P][At_high].nt[1];
		      St[Mdy_Id][P][At_high].nt[1]=St[Mdy_Id][P][At_high].nt[2];
	              St[Mdy_Id][P][At_high].nt[2]=St[Mdy_Id][P][At_high].nt[3];
		 break;
	       case 1:St[Mdy_Id][P][At_high].nt[1]=St[Mdy_Id][P][At_high].nt[2];
	              St[Mdy_Id][P][At_high].nt[2]=St[Mdy_Id][P][At_high].nt[3];
		 break;
	       case 2:St[Mdy_Id][P][At_high].nt[2]=St[Mdy_Id][P][At_high].nt[3];
		 break;
	     }
	   if (St[Mdy_Id][P][At_high].nt[2]>0)
	     {
	       if ((St[Mdy_Id][P][At_high].nt[0]+St[Mdy_Id][P][At_high].nt[1]
		    +St[Mdy_Id][P][At_high].nt[2])/3>=Mid)
		 {                            /*   Downward   */
		   for (k=2;k>0;k--)
		     if (St[Mdy_Id][P][At_high].nt[k]<
			 St[Mdy_Id][P][At_high].nt[k-1])
		       Swap_Notes(Mdy_Id,P,k,k-1,At_high);
		 }
	       else                           /*   Upward   */
		 {
		   for (k=2;k>0;k--)
		     if (St[Mdy_Id][P][At_high].nt[k]>
			 St[Mdy_Id][P][At_high].nt[k-1])
		       Swap_Notes(Mdy_Id,P,k,k-1,At_high);
		 }
	     }
	   else if (St[Mdy_Id][P][At_high].nt[1]>0)
	          {
		   if ((St[Mdy_Id][P][At_high].nt[0]+
			St[Mdy_Id][P][At_high].nt[1])/2>=Mid)
		     {                            /*   Downward   */
		       if (St[Mdy_Id][P][At_high].nt[0]>
			   St[Mdy_Id][P][At_high].nt[1])
			 Swap_Notes(Mdy_Id,P,0,1,At_high);
		     }
		   else                           /*   Upward   */
		     {
		       if (St[Mdy_Id][P][At_high].nt[0]<
			   St[Mdy_Id][P][At_high].nt[1])
			 Swap_Notes(Mdy_Id,P,0,1,At_high);
		     }
		 }
	   St[Mdy_Id][P][At_high].nt[3]=0;return 1;
	 }
       else if (Add==-1)
	      {
		St[Mdy_Id][P][At_high].nt[0]=600;St[Mdy_Id][P][At_high].nt[1]=0;
		St[Mdy_Id][P][At_high].nt[2]=0;St[Mdy_Id][P][At_high].nt[3]=0;
		St[Mdy_Id][P][At_high].act=0;return 1;
	      }
  return -100;
}

void Draw_Note(nx,ny,z,x,y,five,Num,Upward,At_high)
  int nx,ny,z,x,y,five,Num,Upward,At_high;
{
  int i,j,k,FORLIM1,BX,BY,DY;
  char ch,STR1[256];

  BX=x*36;BY=z+4*y;if (At_high==2) DY=0;else DY=(1-At_high)*76;
  if (10<nx && nx<15) { if (At_high==0) BY+=4; }
  else if (!(nx==16 && ny==0)) { SetColor("white");Addline(BX,y,z,At_high); }
  SetColor("yellow");S_bf=(char *)malloc(10);*S_bf='\0';

  if (five==1) 
    {
      if (nx<11)
	{
	  switch (nx) 
	    {
	      case 0:if (ny==1) Point(BX+22,BY+34);
	      case 1:strcpy(S_bf,"D");break;
	      case 2:strcpy(S_bf,"F");break;
	      case 3:strcpy(S_bf,"F1");break;
	      case 4:strcpy(S_bf,"F2");break;
	      case 5:strcpy(S_bf,"F3");break;
	      case 6:strcpy(S_bf,"DP");break;
	      case 7:strcpy(S_bf,"FP");break;
	      case 8:strcpy(S_bf,"FP1");break;
	      case 9:strcpy(S_bf,"FP2");break;
	      case 10:strcpy(S_bf,"FP3");break;
	    }
	  FORLIM1=strlen(S_bf);
	  for (i=0;i<FORLIM1;i++) 
	    {
	      ch=S_bf[i];
	      switch (ch) 
		{
		  case 'D':DrawEllipse(BX+8,BY+32,10,8,0,360);break;
		  case 'F':FillEllipse(BX+8,BY+32,11,9,0,360);break;
		  case '1':
		  case '2':
		  case '3':if (Num==0 || now==0)
		             {
			       sprintf(STR1,"%c",ch);sscanf(STR1,"%ld",&j);
			       for (k=1;k<=j;k++) 
				 {
				   if (Upward==0 || now==0)
				     {
				       DrawEllipse(BX,BY+45-k*4,16,19,10,-70);
				       Line(BX+8,BY+65-k*4,BX+13,BY+62-k*4);
				     }
				   else
				     {
				       DrawEllipse(BX+11,BY+9+k*4,16,19,-10,70);
				       Line(BX+20,BY+9+k*4,BX+25,BY+12+k*4);
				     }
				 }
			     }
		    break;
		  case 'P':if (At_high==1)
		             {
			       if (y<23) Point(BX+23,BY+34);
			       else Point(BX+23,BY+32);
			     }
		           else 
		             {
			       if (y<35) Point(BX+23,BY+34);
			       else Point(BX+23,BY+32);
			     }
		    break;
		}
	    }
	  if (nx>0)
	    {
	      if (Upward==0 || now==0) Line(BX+8,BY+35,BX+8,BY+65);
	      else  Line(BX+19,BY+9,BX+19,BY+38);
	    }
	}
      else if (nx==11 || nx==12)
	     {
	       if (ny==0)
		 {
		   Line(BX+18-12,BY+24+DY,BX+18+12,BY+24+DY);
		   FillRectangle(BX+18-5,BY+25+DY,10,4);
		   if (nx==11) Point(BX+24,BY+26+DY);
		 }
	       else
		 {
		   Line(BX+18-12,BY+40+DY,BX+18+12,BY+40+DY);
		   FillRectangle(BX+18-5,BY+36+DY,10,4);
		   if (nx==11) Point(BX+24,BY+32+DY);
		 }
	     }
           else switch (nx)
	          {
		    case 13:if (ny==0) Draw_Silent(BX+15,BY+42+DY);
	                    else
			      {
				FillEllipse(BX+18,BY+24+DY,5,5,0,360);
				Line(BX+18,BY+26+DY,BX+27,BY+24+DY);
				Line(BX+29,BY+20+DY,BX+18,BY+45+DY);
			      }
		      break;
		    case 14:if (ny==0)
		              {
				FillEllipse(BX+18,BY+24+DY,5,5,0,360);
				FillEllipse(BX+16,BY+29+DY,5,5,0,360);
				Line(BX+18,BY+26+DY,BX+27,BY+24+DY);
				Line(BX+16,BY+31+DY,BX+25,BY+29+DY);
				Line(BX+30,BY+19+DY,BX+19,BY+44+DY);
			      }
		            else
			      {
				FillEllipse(BX+18,BY+24+DY,5,5,0,360);
				FillEllipse(BX+16,BY+29+DY,5,5,0,360);
				FillEllipse(BX+14,BY+34+DY,5,5,0,360);
				Line(BX+18,BY+26+DY,BX+27,BY+24+DY);
				Line(BX+16,BY+31+DY,BX+25,BY+29+DY);
				Line(BX+14,BY+36+DY,BX+23,BY+34+DY);
				Line(BX+30,BY+20+DY,BX+19,BY+45+DY);
			      }	   
		      break;
		    case 15:if (ny==0) Sharp(BX+6,BY+33);
		            else Flat(BX+6,BY+27);
		      break;
		    case 16:if (ny==0) OutTextXY(BX+12,BY+37+DY,"/");
		            else { Point(BX+20,BY+8+DY);Point(BX+20,BY+18+DY); }
		      break;
		    case 17:if (ny==0) Line(BX+35,BY+DY,BX+35,BY+33+DY);
		            else 
			      { 
				Line(BX+33,BY+DY,BX+33,BY+33+DY);
				Line(BX+37,BY+DY,BX+37,BY+33+DY);
			      }
		      break;
		    case 18:if (ny==1) Normal(BX+5,BY+26);break;
		  }
    } 
  else 
    {
      for (nx=0;nx<=17;nx++) 
	{
	  switch (nx) 
	    {
	      case 0:OutTextXY(BX,BY+70,"G");OutTextXY(BX,BY+77,"F");
                break;
	      case 1:OutTextXY(BX+20,BY+29,"D");Flat(BX+12,BY+52);
	             OutTextXY(BX+20,BY+77,"B");
		break;
	      case 2:OutTextXY(BX+20,BY+29,"A");Flat(BX+12,BY+52);
		     OutTextXY(BX+20,BY+77,"E");
		break;
	      case 3:OutTextXY(BX+20,BY+29,"E");Flat(BX+12,BY+52);
		     OutTextXY(BX+20,BY+77,"A");
		break;
	      case 4:OutTextXY(BX+20,BY+29,"B");Flat(BX+12,BY+52);
		     OutTextXY(BX+20,BY+77,"D");
		break;
	      case 5:Sharp(BX+11,BY+9);OutTextXY(BX+20,BY+29,"F");
		     Flat(BX+12,BY+52);OutTextXY(BX+20,BY+77,"G");
		break;
	      case 6:Sharp(BX+11,BY+9);OutTextXY(BX+20,BY+29,"C");
		     Flat(BX+12,BY+52);OutTextXY(BX+20,BY+77,"C");
		break;
	      case 7:OutTextXY(BX+20,BY+29,"C");OutTextXY(BX+20,BY+77,"/");
		break;
	      case 8:OutTextXY(BX+20,BY+29,"0");
		     FillEllipse(BX+22,BY+54,5,5,0,360);
		     FillEllipse(BX+22,BY+70,5,5,0,360);
		break;
	      case 9:OutTextXY(BX+20,BY+29,"1");Underline_(BX+19,BY+66,1);
		break;
	      case 10:OutTextXY(BX+20,BY+29,"2");Underline_(BX+19,BY+66,2);
		break;
	      case 11:OutTextXY(BX+20,BY+29,"3");Underline_(BX+19,BY+66,3);
		break;
	      case 12:OutTextXY(BX+20,BY+29,"4");
	              FillEllipse(BX+23,BY+50,5,5,0,360);
		break;
	      case 13:OutTextXY(BX+20,BY+29,"5");
	              FillEllipse(BX+23,BY+60,5,5,0,360);
		break;
	      case 14:OutTextXY(BX+20,BY+29,"6");
	              FillEllipse(BX+23,BY+70,5,5,0,360);
		break;
	      case 15:OutTextXY(BX+20,BY+29,"7");Line(BX+24,BY+49,BX+24,BY+78);
		break;
	      case 16:OutTextXY(BX+20,BY+29,"-");Line(BX+22,BY+49,BX+22,BY+78);
                      Line(BX+29,BY+49,BX+29,BY+78);
		break;
	      case 17:Sharp(BX+9,BY+12);Flat(BX+9,BY+49);break;
	    }
	}
    }
}

void Display_Note(Mdy_Id,P,Z,X,Step,At_high)
  int Mdy_Id,P,Z,X,Step,At_high;
{
  int Note,Act,Nx,Ny,y,step,sn,plus,Num,Num_Lim,Note_1,Note_2,Note_3,Note_4,up,
      Norm,Dy,Dz,Mid;

  step=Step;sn=plus=up=0;Num_Lim=4;if (At_high==0) Mid=50;else Mid=71;
  switch (At_high)
    {
      case 0:Dy=V_Ht/4;Dz=V_Ht+155;break;
      case 1:Dy=V_Ht/4;Dz=V_Ht+75;break;
      case 2:Dy=0;Dz=75;break;
    }

  if (now==0) { Act=tmp_buf[Mdy_Id][P].act;Num_Lim=1; }
  else
    {
      if (P>St[Mdy_Id][0][At_high].nt[0]+1 || St[Mdy_Id][P][At_high].nt[0]==600)
	return;
      Act=St[Mdy_Id][P][At_high].act;

      if (St[Mdy_Id][P][At_high].nt[0]>200) 
	Note_1=St[Mdy_Id][P][At_high].nt[0] % 200;
      else Note_1=St[Mdy_Id][P][At_high].nt[0];
      if (St[Mdy_Id][P][At_high].nt[1]>200) 
	Note_2=St[Mdy_Id][P][At_high].nt[1] % 200;
      else Note_2=St[Mdy_Id][P][At_high].nt[1];
      if (St[Mdy_Id][P][At_high].nt[2]>200) 
	Note_3=St[Mdy_Id][P][At_high].nt[2] % 200;
      else Note_3=St[Mdy_Id][P][At_high].nt[2];
      if (St[Mdy_Id][P][At_high].nt[3]>200) 
	Note_3=St[Mdy_Id][P][At_high].nt[3] % 200;
      else Note_4=St[Mdy_Id][P][At_high].nt[3];

      if (Note_4>0) { if ((Note_4+Note_3+Note_2+Note_1)/4<Mid) up=1; }
      else if (Note_3>0) { if ((Note_3+Note_2+Note_1)/3<Mid) up=1; }
           else if (Note_2>0) { if ((Note_2+Note_1)/2<Mid) up=1; }
                else if (Note_1>0 && Note_1<Mid) up=1;
    }

  for (Num=0;Num<Num_Lim;Num++)
    {
      Norm=0;
      if (now>0)
	{
	  Note=St[Mdy_Id][P][At_high].nt[Num];
	  if (200<Note && Note<320) { Norm=1;Note=Note % 200; }
	}
      else Note=tmp_buf[Mdy_Id][P].note;

      if (Num>0 && Note==0) return;
      if (five) 
	switch (Note) 
	  {
	    case 0:switch (Act) 
	             {
		       case 96:Nx=11;Ny=0;break;
		       case 48:Nx=11;Ny=1;break;
		       case 64:Nx=12;Ny=0;break;
		       case 32:Nx=12;Ny=1;break;
		       case 16:Nx=13;Ny=0;break;
		       case 8:Nx=13;Ny=1;break;
		       case 4:Nx=14;Ny=0;break;
		       case 2:Nx=14;Ny=1;break;
		     }
	           y=17+Dy;
	      break;
	    default:if (Note>=-99 && Note<=-1 || Note==600) 
	              {   
			if (Note==600) { Nx=18;Ny=0; }
			else
			  {
			    Nx=16;Ny=0;y=17+Dy;SetColor("cyan");
			    Out_I_XY(X*36+6,Z+Dz,(-Note));
			  }
		      } 
		    else if (0<Note && Note<110) 
		           {
			     switch (abs(Act)) 
			       {
			         case 64:
			         case 96:Nx=0;break;
				 case 32:Nx=1;break;
				 case 16:Nx=2;break;
				 case 8:Nx=3;break;
				 case 4:Nx=4;break;
				 case 2:Nx=5;break;
				 case 48:Nx=6;break;
				 case 24:Nx=7;break;
				 case 12:Nx=8;break;
				 case 6:Nx=9;break;
				 case 3:Nx=10;break;
			       }
			     switch (abs(Act)) 
			       {
			         case 64:Ny=0;break;
				 case 96:Ny=1;break;
				 default:Ny=1-Note/69;break;
			       }
			     if (Norm==1) /* Back to normal */
			       {
				 y=Nt_Y(Note,At_high);Addline(X*36,y,Z,At_high);
				 Draw_Note(18,1,Z,X,y-3,five,0,0,At_high);
			       }
			     else 
			       {
				 if (White_Key(Note,At_high)==0)
				   { Note--;plus=1;}
				 y=Nt_Y(Note,At_high);Addline(X*36,y,Z,At_high);
				 if (plus==1) 
				   { 
				     plus=0;
				     Draw_Note(15,0,Z,X,y-2,five,0,0,At_high);
				   }
			       }
			     Draw_Note(Nx,Ny,Z,X,y,five,Num,up,At_high);
			   }
	      break;
	    } /* Note */
      else 
	switch (Note) 
	  {
	    case 0:Nx=8;Ny=0;y=0;break;
	    default:if (Note>=-99 && Note<=-1) 
		      { Nx=7;Ny=1;y=0;Out_I_XY(X*36,Z+24,(-Note)); } 
	            else if (0<Note && Note<120) 
			   {
			     Ny=0;y=0;sn=Note;Nt_nx(step,&sn);
			     _L:switch (sn) 
			          {
				    case 36:
				    case 48:
				    case 60:Nx=9;break;
				    case 38:
				    case 50:
				    case 62:Nx=10;break;
				    case 40:
				    case 52:Nx=11;break;
				    case 41:
				    case 53:Nx=12;break;
				    case 31:
				    case 43:
				    case 55:Nx=13;break;
				    case 33:
				    case 45:
				    case 57:Nx=14;break;
				    case 35:
				    case 47:
				    case 59:Nx=15;break;
				    default:Sharp(X*36+10,Z+y*4+33);
					    Draw_Note(Nx,Ny,Z,X,y,five,Num,0,
						      At_high);
					    sn--;goto _L;
				      break;
				  }
			     Addot(X,Z);
			   }
	      break;
	  }
      Draw_Note(Nx,Ny,Z,X,y,five,Num,up,At_high);
    }
}

void Show_Word(Word_Id,Page)
  int Word_Id,Page;
{
  int Line;
  char *W_Line;

  Use_Font("7x14");
  for (Line=0;Line<2;Line++)
    {
      Rub(47,Line*Dist+148,47+7*150,13,"NavyBlue");SetColor("cyan");
      W_Line=(char *)malloc(160);*W_Line='\0';
      if (Page==0 && Line==0)
	{ 
	  sprintf(W_Line+strlen(W_Line),"%s",Sub_Str(Words[Word_Id],0,115));
	  OutTextXY(35*7+47,159,W_Line);
	}
      else
	{
	  sprintf(W_Line+strlen(W_Line),"%s",Sub_Str(Words[Word_Id],
					     Page*300+Line*150-Text_Base,150));
	  OutTextXY(47,Line*Dist+159,W_Line);
	}
    }
}

void Show_Piano(x,y,button)
  int x,y,button;
{
  int j,k,X,Y,LY;

  Rub(x-41,y-415,1133,626,"MediumBlue");XSetLineAttributes(display,gc,3,0,0,0);
  SetColor("LimeGreen");DrawRectangle(x-39,y-400,1129,577);SetColor("cyan");
  DrawRectangle(x-6,y-6,1064,142);XSetLineAttributes(display,gc,1,0,0,0);
  SetColor("white");Draw_A_Staff(1,-60);LY=566;Use_Font("6x12");
  SetColor("white");for (j=0;j<2;j++) Line(1117+j*3,270+28,1117+j*3,270+269);
  if (button==Button2)
    { OutTextXY(10,y+170,"Note");SetColor("cyan");OutTextXY(20,y+153,"Y"); }
  
  for (j=0;j<24;j++)
    {
      X=j*20+51;Y=586-j*4;
      if (j<12) 
	{ 
	  SetColor("grey");
	  for (k=j;k<12;k++) Line(X-3,LY-(k/2)*8+20,X+14,LY-(k/2)*8+20);
	}
      if (j==23) 
	{ SetColor("grey");Line(X-3,LY-(23/2)*8+20,X+14,LY-(23/2)*8+20); }
      SetColor("gold");DrawEllipse(X,Y,10,8,0,23040);
      SetColor("LightSkyBlue");Line(X+5,Y+11,X+5,y+3);
      if (button==Button2 && j<23)
	{
	  Out_I_XY(X-2,y+153,51-j);
	  SetColor("white");Out_I_XY(X-2,y+170,Y_Nt(53-j+V_Ht/4,0));
	}
    }
  for (j=24;j<53;j++) 
    { 
      X=j*20+31;Y=558-j*4;
      if (j>35) 
	{ 
	  SetColor("white");
	  for (k=35;k<j;k++) Line(X-3,LY-12-(k/2)*8,X+14,LY-12-(k/2)*8);
	}
      if (j==24) 
	{ SetColor("white");Line(X-3,LY-4-(24/2)*8,X+14,LY-4-(24/2)*8); }
      SetColor("gold");DrawEllipse(X,Y,10,8,0,23040);
      SetColor("cyan");Line(X+5,Y+11,X+5,y+3);
      if (button==Button2)
	{
	  Out_I_XY(X-2,y+153,52-j);
	  SetColor("white");Out_I_XY(X-2,y+170,Y_Nt(46-j+V_Ht/4,1));
	}
    }
  SetColor("white");DrawRectangle(x+5,y+5,1042,120);
  for (k=0;k<7;k++)
    {
      switch(k)
	{
	  case 0:SetColor("pink");break;
	  case 1:SetColor("violet");break;
	  case 2:SetColor("HotPink");break;
	  case 3:SetColor("LightSkyBlue");break;
	  case 4:SetColor("SkyBlue");break;
	  case 5:SetColor("DeepSkyBlue");break;
	  case 6:SetColor("CornflowerBlue");break;
	}
      FillRectangle(x+140*k+47,y+6,140,119);
    }
  Rub(x+6,y+6,40,119,"thistle");Rub(x+1027,y+6,20,119,"LightSlateBlue");
  SetColor("white");for (k=1;k<52;k++) Line(x+20*k+6,y+6,x+20*k+6,y+125);
  for (j=0;j<7;j++) 
    for (k=0;k<6;k++) if (k!=2) Rub(x+140*j+20*k+61,y+6,10,77,"black");
  Rub(x+21,y+6,10,77,"black");
}

int Piano_Note(px,py,mx,my)
  int px,py,mx,my;
{
  int j,k,v,note;

  XSetLineAttributes(display,gc,1,0,0,0);
  if ((px+5<mx)&&(mx<px+1047) && (py+5<my)&&(my<py+125)) 
    {
      if ((px+20<mx)&&(mx<px+32) && (py+5<my)&&(my<py+84)) 
	{ highlight(px+21,py+6,11,78);return(22); }
      for (j=0;j<7;j++) 
	{
	  note=23+12*j;
	  for (k=0;k<6;k++)
	    {
	      if (k==2) note++;
	      else
		{
		  note+=2;v=px+140*j+20*k;
		  if ((v+60<mx)&&(mx<v+80) && (py+5<my)&&(my<py+82))
		    { highlight(v+61,py+6,11,78);return(note); }
		}
	    }
	}
      if ((px+5<mx)&&(mx<px+27) && (py+5<my)&&(my<py+126)) 
	{ highlight(px+5,py+6,21,119);return(21); }
      else if ((px+25<mx)&&(mx<px+47) && (py+5<my)&&(my<py+126))
	     { highlight(px+25,py+6,21,119);return(23); }
           else if ((px+1027<mx)&&(mx<px+1049) && (py+5<my)&&(my<py+126))
	          { highlight(px+1026,py+6,21,119);return(108); }
      for (j=0;j<7;j++) 
	{
	  note=22+12*j;
	  for (k=0;k<7;k++)
	    {
	      note+=2;if (k==3) note--;v=px+140*j+20*k;
	      if ((v+47<mx)&&(mx<v+69) && (py+5<my)&&(my<py+126))
		{ highlight(v+46,py+6,21,119);return(note); }
	    }
	}
    }
  return(0);
}

void Move_Word(From_kind,From_num,To_kind,To_num)
  int From_kind,From_num,To_kind,To_num;
{
  int i,A_Num,A_Lim,Z_Num,Z_Lim,Re_New,Keep;

  A_Num=From_kind*1000+From_num+1;A_Lim=From_kind*1000+1000;
  Z_Num=To_kind*1000+To_num+1;Re_New=0;Keep=-1;

  if (To_kind==-1)
    {
      for (i=0;i<Word_Num;i++)
	if (A_Num<=Words_Array[i] && Words_Array[i]<=From_kind*1000+To_num+1)
	  { Words_Array[i]=0;Re_New=1; }
        else if (From_kind*1000+To_num+1<Words_Array[i] && Words_Array[i]<A_Lim)
	       { Words_Array[i]-=To_num-From_num+1;Re_New=1; }
    }
  else
    {
      Z_Lim=To_kind*1000+1000;
      for (i=0;i<Word_Num;i++)
	{
	  if (Words_Array[i]==A_Num) { Keep=i;Re_New=1; }
	  else if (A_Num<Words_Array[i] && Words_Array[i]<A_Lim) 
	         { Words_Array[i]--;Re_New=1; }
	  if (Z_Num<=Words_Array[i] && Words_Array[i]<Z_Lim)
	    { Words_Array[i]++;Re_New=1; }
	}
      if (Re_New==1 && Keep!=-1) Words_Array[Keep]=Z_Num;
    }
  if (Re_New==1) Word_Num=-Word_Num;  /* Word_Num<0  means need to save  */
}

void Move_Melody(From_kind,From_num,To_kind,To_num)
  int From_kind,From_num,To_kind,To_num;
{
  int i,j,Num,Ptr,Len;

  if (From_kind==To_kind && From_num==To_num) return;
  if (From_kind==Max_kind-1)
    {
      if (To_kind!=Max_kind-1) return;
      else
	{
	  con=cont[From_num];Delete_Set(From_num);
	  for (i=content[Max_kind-1];i>To_num-1;i--)
	    {
	      *cont[i+1].Set_name='\0';S_bf=(char *)malloc(10);*S_bf='\0';
	      sprintf(S_bf,"%5ld",i+2);strcpy(cont[i+1].Set_name,S_bf);ch='.';
	      sprintf(cont[i+1].Set_name+strlen(cont[i+1].Set_name),"%c",ch);
	      sprintf(cont[i+1].Set_name+6,"%s",Sub_Str(cont[i].Set_name,6,44));
	      for (j=0;j<6;j++)
		{
		  cont[i+1].tempo[j]=cont[i].tempo[j];
		  cont[i+1].instru[j]=cont[i].instru[j];
		}
	    }
	  content[Max_kind-1]++;

	  *cont[To_num].Set_name='\0';S_bf=(char *)malloc(10);*S_bf='\0';ch='.';
	  sprintf(S_bf,"%5ld",To_num+1);strcpy(cont[To_num].Set_name,S_bf);
	  sprintf(cont[To_num].Set_name+strlen(cont[To_num].Set_name),"%c",ch);
	  sprintf(cont[To_num].Set_name+6,"%s",Sub_Str(con.Set_name,6,44));
	  for (j=0;j<6;j++)
	    {
	      cont[To_num].tempo[j]=con.tempo[j];
	      cont[To_num].instru[j]=con.instru[j];
	    }
	}
    }
  else 
    {
      if (now!=From_kind) { now=From_kind;if (content[now]>0) Load(); }

      if (now==0) 
	for (i=0;i<29;i++)
	  {
	    sample[i][0].nt[0]=tmp[From_num][i].note;
	    sample[i][0].act=tmp[From_num][i].act;
	  }
      else for (i=0;i<M_Len;i++)
	     {
	       sample[i][0]=St[From_num][i][0];sample[i][1]=St[From_num][i][1];
	       sample[i][2]=St[From_num][i][2];
	     }
      sample_name=(char *)malloc(50);*sample_name='\0';
      Len=strlen(names[From_kind*1000+From_num])-6;
      Str_Append(sample_name,Sub_Str(names[From_kind*1000+From_num],6,Len),Len);
      Del=From_num;tail=content[now]-1;Save(1,tail);Del=-1;
      
      if (now!=To_kind) { now=To_kind;if (content[now]>0) Load(); }
      if (To_num>=content[now]) To_num=content[now];
      else
	{
	  Ptr=content[now];names[now*1000+Ptr+1]=(char *)malloc(50);
	  *names[now*1000+Ptr+1]='\0';Num=To_kind*1000+Ptr;
	  S_bf=(char *)malloc(10);*S_bf='\0';sprintf(S_bf,"%5ld",Num+1);
	  strcpy(names[Num],S_bf);Str_Append(names[Num],'.',1);

	  for (j=Ptr;j>To_num-1;j--) 
	    {
	      if (now==0) for (i=0;i<29;i++) tmp[j+1][i]=tmp[j][i];
	      else for (i=0;i<M_Len;i++) 
		     {
		       St[j+1][i][0]=St[j][i][0];St[j+1][i][1]=St[j][i][1];
		       St[j+1][i][2]=St[j][i][2];
		     }
	      Num=now*1000+j;Len=strlen(names[Num])-6;
	      sprintf(names[Num+1]+6,"%s",Sub_Str(names[Num],6,Len));

	      names[Num]=(char *)malloc(50);*names[Num]='\0';
	      S_bf=(char *)malloc(10);*S_bf='\0';sprintf(S_bf,"%5ld",Num+1);
	      sprintf(S_bf,"%5ld",Num+1);strcpy(names[Num],S_bf);
	      Str_Append(names[Num],'.',1);
	    }
	}

      if (now==0) 
	for (i=0;i<29;i++) 
	  {
	    tmp[To_num][i].note=sample[i][0].nt[0];
	    tmp[To_num][i].act=sample[i][0].act;
	  }
      else for (i=0;i<M_Len;i++)
	     {
	       St[To_num][i][0]=sample[i][0];St[To_num][i][1]=sample[i][1];
	       St[To_num][i][2]=sample[i][2];
	     }
      Num=To_kind*1000+To_num;names[Num]=(char *)malloc(50);*names[Num]='\0';
      S_bf=(char *)malloc(10);*S_bf='\0';sprintf(S_bf,"%5ld",Num+1);
      strcpy(names[Num],S_bf);Str_Append(names[Num],'.',1);
      Str_Append(names[Num],sample_name,strlen(sample_name));
      content[now]+=1;tail=content[now];
      Move_Word(From_kind,From_num,To_kind,To_num);Save(1,tail);
    }
}

void Switch_Melody(From_kind,To_kind)
  int From_kind,To_kind;
{
  int i,Num_F,Num_T,Fn,Tn,Delt;

  Num_F=content[From_kind];Num_T=content[To_kind];
  Fn=From_kind*1000;Tn=To_kind*1000;
  for (i=0;i<Num_F;i++)
    {
      Buffer[i]=(char *)malloc(50);*Buffer[i]='\0';
      sprintf(Buffer[i]+strlen(Buffer[i]),Sub_Str(names[Fn+i],5,45));
      names[Fn+i]=(char *)malloc(50);*names[Fn+i]='\0';
      Atom_array[i][From_kind+1]=(char *)malloc(50);
      *Atom_array[i][From_kind+1]='\0';
    }
  for (i=0;i<Num_T;i++)
    {
      S_bf=(char *)malloc(10);*S_bf='\0';sprintf(S_bf,"%5ld",Fn+i+1); 
      strcpy(names[Fn+i],S_bf);
      sprintf(names[Fn+i]+strlen(names[Fn+i]),Sub_Str(names[Tn+i],5,45));
      strcpy(Atom_array[i][From_kind+1],names[Fn+i]);
    }
  for (i=0;i<Num_F;i++)
    {
      names[Tn+i]=(char *)malloc(50);*names[Tn+i]='\0';
      Atom_array[i][To_kind+1]=(char *)malloc(50);
      *Atom_array[i][To_kind+1]='\0';S_bf=(char *)malloc(10);*S_bf='\0';
      sprintf(S_bf,"%5ld",Tn+i+1);strcpy(names[Tn+i],S_bf);
      sprintf(names[Tn+i]+strlen(names[Tn+i]),Buffer[i]);
      strcpy(Atom_array[i][To_kind+1],names[Tn+i]);
    }
  for (i=Num_F;i<Num_T-Num_F+1;i++)
    {
      names[Tn+i]=(char *)malloc(50);*names[Tn+i]='\0';
      Atom_array[i][To_kind+1]=(char *)malloc(50);
      *Atom_array[i][To_kind+1]='\0';
    }
  Delt=1000*(From_kind-To_kind);
  for (i=0;i<Word_Num;i++) 
    if (Fn<=Words_Array[i] && Words_Array[i]<Fn+1000) Words_Array[i]-=Delt;
    else if (Tn<=Words_Array[i] && Words_Array[i]<Tn+1000) Words_Array[i]+=Delt;
  Fn=content[From_kind];content[From_kind]=content[To_kind];content[To_kind]=Fn;
}

void Play()
{
  int x, y;

  if (ptr_.nt<0) 
    {
      if (uniset[-ptr_.nt[0]][0]<0) 
        {
          x=0;
          do {
	       for (y=1;y<=10;y++) 
		 { /* sound(uniset[-ptr_.nt[0]][y]);delay(1);*/ }
	       x+=10;
             } while (x+uniset[-ptr_.nt[0]][0]<=-10);
        } 
      else 
        {
          for (y=1;y<=10;y++) 
            {
	      /*    sound(uniset[-ptr_.nt[0]][y]); */
	      /*    delay((int)floor(0.1*uniset[-ptr_.nt[0]][0]+0.5)); */
            }
        }
    } 
  else if (ptr_.nt[0] != 0) 
         {
           if (St[M_Id][7][0].nt[0]==0) 
	     { /* sound(ptr_.nt[0]);delay(ptr_.at); */ } 
           else 
             {
               x=0;
               do {
	            for (y=0;y<=39;y++) 
		      { /*sound(ptr_.nt[0]*mix[y]);delay(1); */ }
	            x+=40;
                  } while (ptr_.at-x>=40);
             }
      /*      nosound(); */
           if (ptr_.cm != 0) { /*    delay(ptr_.cm); */ }
         } 
       else { /*  delay(777); */ }
   /*     nosound(); */
}  /*Play*/

void Sing(q)
  int q;
{
  int tx,rpt,cut,i,k,p,w,x,y,on[7][2],ms[7],present[7],current[7],FORLIM1;
  double d,spd;
  fast all[226],*WITH;
  char STR1[256];

  if (Signal==1) goto _LR;if (Signal==-1) dancer();
  Rub(0,0,1139,862,"SteelBlue");SetColor("green");
  OutTextXY(400,200,"--- Sing the melody(s) ---");
  if (next==0) 
    {
      OutTextXY(200,600,"S--single  C--combine");OutTextXY(300,660,"Choice: ");
      ch=GetKey();sprintf(STR1,"%c",ch);OutTextXY(390,660,STR1);
      if (ch=='C') Signal=2;
    }
  if (Signal==2 && (hold==0 || content[0]==0)) return;
  OutTextXY(500,500,"Content= ");
  if (Signal==2) Out_I_XY(600,500,hold);else Out_I_XY(600,500,content[n]);
  OutTextXY(400,600,"From:");readat(460,600,3,&k);
  OutTextXY(600,600,"To:");readat(640,600,3,&q);
  if (Signal==2 && (q>hold || k>q) || Signal!=2 && (q>content[n] || k>q)) 
    { OutTextXY(500,600,"No such melody(s)");/* delay(3000); */ return; }
  XClearWindow(display,win);OutTextXY(280,0,"Instrument");
  OutTextXY(600,30,"0--pure");y=13;p=1;
  do {
       x=(p-1)%5*128;y=((p-1)/5+2)*30;Out_I_XY(x,y,p);OutTextXY(x+24,y,".");
       OutTextXY(x+32,y,tim[p-1]->tool);p++;
     } while (p<=Timbre_num);
  OutTextXY(800,600, "Choice: ");readat(900,600,3,&tx);
  if (tx>=1 && tx<=Timbre_num) { tim_pt=*tim[tx-1];Mixup(); } else tx=0;
  if (now != n) { now=n;Load(); }
  XClearWindow(display,win);Line(0,30,639,30);Line(0,160,639,160);
  if (Signal!=1) for (w=0;w<=6;w++) { Square(w,1);Square(w,0); }
  SetColor("white");
  OutTextXY(300,30,"Timer=     Measure=     Speed=       Percent=    ");lock=0;
  OutTextXY(100,800,"F10      F1       F2       F3       F4       F5       F6");
_LR:
  for (p=k;p<=q;p++) 
    {
      for (j=0;j<=6;j++) { ms[j]=0;present[j]=1; }
      current[0]=0;x=0;rpt=-1;for (j=1;j<=6;j++) current[j]=1;
      for (j=1;j<=226;j++) 
        { WITH=&all[j-1];WITH->nt[0]=200;WITH->at=0;WITH->cm=0; }
      if (Signal==2) 
        {
          con=cont[p];
          for (j=1;j<=226;j++) 
            {
	      at=0;
	      switch (j) 
                {
                  case 1:nt=-113;break;
     	          case 2:nt=con.tempo[0];break;
                  case 3:nt=con.instru[0];break;
   	          case 4:
	          case 5:nt=100;break;
	          case 6:
	          case 7:
	          case 8:
	          case 9:nt=0;break;
	          case 10:
	          case 11:
	          case 12:
	          case 13:
	          case 14:
	          case 15:nt=con.tempo[j-9];at=con.instru[j-9];break;
	          default:if (j>=16 && j<=226) nt=0;break;
	        }
/*	      sample[j-1][0].nt[0]=nt;sample[j-1][0].act=at; */
            }
        } 
      else 
        {
          j=0;
          do {
	       j++;
	       if (now==0)
		 {
		   sample[j-1][0].nt[0]=tmp[p-1][j-1].note;
		   sample[j-1][0].act=tmp[p-1][j-1].act;
		 }
	       else 
		 {
		   sample[j-1][0]=St[p-1][j-1][0];
		   sample[j-1][1]=St[p-1][j-1][1];
		   sample[j-1][2]=St[p-1][j-1][2];
		 }
             } while (sample[j-1][0].nt[0] != 200);
        }
      if (Signal==1) 
        {
          if (sample[7][0].nt[0]>Timbre_num || now==0) tx=0;
          else { tx=sample[7][0].nt[0];tim_pt=*tim[tx-1];Mixup(); }
        }
      for (j=0;j<=6;j++) 
        {
          if (j==0) 
            {
	      on[0][0]=(sample[0][0].nt[0]>-112 || now==0);
	      if (sample[St_Start][0].nt[0]==0&&now>0) on[0][1]=0;
	      else on[0][1]=on[0][0];
            } 
          else if (now==0) 
                 { on[j][0]=0;on[j][1]=0; } 
               else 
                 {
	           on[j][0]=(sample[j+8][0].nt[0]>0 && 
			     sample[j+8][0].nt[0]<=content[0]);
	           if (tmp[sample[j+8][0].nt[0]-1][2].note==0) on[j][1]=0;
	           else on[j][1]=on[j][0];
                 }
        }
      if (now==0) 
	{ Timer=sample[1][0].nt[0];Measure=sample[1][0].act;pct=30;spd=0.007; } 
      else 
        {
          Timer=sample[1][0].nt[0];Measure=sample[2][0].nt[0];
          pct=sample[4][0].nt[0];spd=1.0/(sample[3][0].nt[0]*2);
        }
      if (Signal==-1) spd*=0.2;
      if (Signal!=1) 
        {
	  Rub(360,30,78,37,"white");Rub(550,30,182,37,"green");
          if (now==0) { OutTextXY(600,30,"Tempo No. ");Out_I_XY(800,30,p); } 
          else OutTextXY(630,30,names[now*1000+p]);
	  Rub(400,70,26,37,"green");Rub(570,70,26,37,"green");
          Rub(720,70,26,37,"green");Rub(1000,70,26,37,"green");
          Out_I_XY(400,70,Timer);Out_I_XY(570,70,Measure);Out_I_XY(720,70,pct);
          if (now==0) Out_D_XY(1000,70,70.0);
          else Out_I_XY(1000,70,sample[3][0].nt[0]);
        }
      cut=(int)floor(60000*spd*Timer*Measure+0.5);
      if (lock) i=sample[0][0].nt[0];else if (now==0) i=2;else i=St_Start;
      if (now ==0) 
        {
          do {
	       i++;all[i-3].nt[0]=sample[i-1][0].nt[0];
	       d=freq;FORLIM1=all[i-3].nt[0];
	       for (w=31;w<FORLIM1;w++) d*=1.0594631;
	       all[i-3].nt[0]=(int)floor(d+.5);
               rlact=9.375*Measure*sample[i-1][0].act*spd;
	       all[i-3].at=(int)floor(rlact*pct+0.5);
	       all[i-3].cm=(int)floor(rlact*(100-pct)+0.5);
             } while (sample[i][0].nt[0] != 200);
          WITH=&all[i-2];WITH->nt[0]=200;WITH->at=0;WITH->cm=0;
	}
      else 
	{
	  do {
	       if (lock) i--;else i++;
	       if (sample[i-1][0].nt[0]>=31 && sample[i-1][0].nt[0]<=62) 
		 {
		   switch (sample[i-1][0].nt[0]) 
		     {
	               case 55:
	               case 43:
	               case 31:if (lock)
	                         all[sample[0][0].nt[0]-i+127].nt[0]=
				   sample[i-1][0].nt[0]+
		                 sample[(int)((int)floor(3.5*sample[6][0].nt[0]+
                                 0.5))][0].act;
	                       else all[i-16].nt[0]=sample[i-1][0].nt[0]+
			            sample[(int)((int)floor(
				    3.5*sample[6][0].nt[0]+0.5))][0].act;
			 break;
		       case 53:
		       case 41:if (lock)
			         all[sample[0][0].nt[0]-i+127].nt[0]=
                                     sample[i-1][0].nt[0]+sample[(int)floor(3.5*
                                     sample[6][0].nt[0]+0.5)+1][0].act;
		               else all[i-16].nt[0]=sample[i-1][0].nt[0]+
				    sample[(int)floor(3.5*sample[6][0].nt[0]+
						      0.5)+1][0].act;
			 break;
		       case 52:
		       case 40:if (lock)
	                          all[sample[0][0].nt[0]-i+127].nt[0]=
				    sample[i-1][0].nt[0]+sample[2][0].act;
		               else all[i-16].nt[0]=sample[i-1][0].nt[0]+
				    sample[2][0].act;
			 break;
		       case 50:
		       case 62:
		       case 38:if (lock)
	                          all[sample[0][0].nt[0]-i+127].nt[0]=
				    sample[i-1][0].nt[0]+sample[3][0].act;
		               else all[i-16].nt[0]=sample[i-1][0].nt[0]+
				       sample[3][0].act;
			 break;
		       case 48:
		       case 60:
		       case 36:if (lock) 
			         all[sample[0][0].nt[0]-i+127].nt[0]=
				   sample[i-1][0].nt[0]+sample[4][0].act;
		               else all[i-16].nt[0]=sample[i-1][0].nt[0]+
				       sample[4][0].act;
			 break;
		       case 47:
		       case 59:
		       case 35:if (lock) 
			         all[sample[0][0].nt[0]-i+127].nt[0]=
				   sample[i-1][0].nt[0]+sample[5][0].act;
		               else all[i-16].nt[0]=sample[i-1][0].nt[0]+
				       sample[5][0].act;
			 break;
		       case 45:
		       case 57:
		       case 33:if (lock) 
			         all[sample[0][0].nt[0]-i+127].nt[0]=
				   sample[i-1][0].nt[0]+sample[6][0].act;
	                       else all[i-16].nt[0]=sample[i-1][0].nt[0]+
				       sample[6][0].act;
			 break;
		     }
		 } 
	       else all[i-16].nt[0]=sample[i-1][0].nt[0];
	       if (lock) 
		 {
		   if (all[sample[0][0].nt[0]-i+127].nt[0]>0) 
		     {
		       d=freq;FORLIM1=all[sample[0][0].nt[0]-i+127].nt[0];
		       for (w=31;w<FORLIM1;w++) d*=1.06;
		       all[sample[0][0].nt[0]-i+127].nt[0]=(int)floor(d+0.5);
		     }
		 } 
	       else if (all[i-16].nt[0]>0) 
		      {
			d=freq;FORLIM1=all[i-16].nt[0];
			for (w=31;w<FORLIM1; w++) d*=1.0594631;
			all[i-16].nt[0]=(int)floor(d+0.5);
		      }
	       rlact=9.375*Measure*sample[i-1][0].act*spd;
	       all[i-16].at=(int)floor(rlact*pct+0.5);
	       all[i-16].cm=(int)floor(rlact*(100-pct)+0.5);
	     } while (!(lock && i==16) && (lock || sample[i][0].nt[0] != 200));
	  if (lock) 
	    { 
	      WITH=&all[sample[0][0].nt[0]+112];WITH->nt[0]=200;
	      WITH->at=0;WITH->cm=0;
	    } 
	  else { WITH=&all[i-St_Start];WITH->nt[0]=200;WITH->at=0;WITH->cm=0; }
	}
      if (sample[5][0].nt[0]==0 || now==0) y=0;
      else 
	{
	  w=0;FORLIM1=sample[5][0].nt[0];
	  for (j=16;j<=FORLIM1;j++) w+=abs(sample[j-1][0].act);y=cut-w;
	}
      if (on[0][0]) ptr_=all[0];else { ptr_.nt[0]=0;ptr_.at=0;ptr_.cm=0; }
      while (ptr_.nt[0] != 200) 
	{
	  for (j=0;j<=6;j++) 
	    {
	      if ((Signal != 1) & (!(ch=GetKey()))) 
		{
	          w=ch-':';
		  switch (w) 
		    {
		      case 1:
		      case 2:
		      case 3:
		      case 4:
		      case 5:
		      case 6:if (sample[w+8][0].nt[0]>0 && sample[w+8][0].nt[0]<=
				     content[0]) 
			       {
				 dis(on[w]);
				 if (on[w][0]) Square(w,1);else Square(w,0);
			       }
			break;
		      case 10:if (St[k][0][0].nt[0]>-112) 
			        {
				  dis(on[0]);
				  if (on[0][0]) Square(0,1);else Square(0,0);
				}
			break;
		    }
		  /*if (ch=='Q'||ch=='P') && !on[0][0]) g_l(ch,'D',0,199,1); */
		  if (ch=='&') {  /*     nosound(); */  goto _LU; }
		}
	      if (on[j][0]) 
		{
		  if (j==0) 
		    {
		      if (y-ms[0]>=ptr_.at+ptr_.cm) 
			{
			  if (y>=cut) y=0;
			  if (rpt==1) { present[0]=x-1;x=0;rpt=-1; }
_LS:      		  present[0]++;
			/*  if (Signal==-1) { show(1);show(2);show(3); } */
			  if (all[present[0]-1].at<0) 
			    {
			      all[present[0]-1].at=-all[present[0]-1].at;
			      if (x==0) x=present[0];else rpt=1;
			    }
			  ptr_=all[present[0]-1];
			  if (ptr_.nt[0]<0) 
			    {
			      if (uniset[-ptr_.nt[0]][0]<0) 
				{
				  i=0;
				  do {
				       for (w=1;w<=10;w++) 
				         {
					   /*sound(uniset[-ptr_.nt[0]][w]);
					     delay(1);*/
				         }
				       i+=10;
				     } while (i+uniset[-ptr_.nt[0]][0]<=-10);
			        } 
			      else 
				{
				  for (w=1;w<=10;w++) 
				    {
				      /*    sound(uniset[-ptr_.nt[0]][w]); */
				      /*delay((int)floor(0.1*
					uniset[-ptr_.nt[0]][0]+0.5)); */
				    }
				}
			      goto _LS;
			    }
			  if (ptr_.nt[0]==0 || ptr_.nt[0]==200) 
			    { on[0][1]=0;if (Signal != 1) Square(0,0); }
			  else 
			    { on[0][1]=1;if (Signal != 1) Square(0,1); }
			  if (ptr_.nt[0]==200) { on[0][0]=0; /* nosound(); */ }
			  ms[0]=y;
			} 
		      else if (y-ms[0]>=ptr_.at) 
		             { on[0][1]=0;if (Signal != 1) Square(0,0); }
		      if (on[0][1]) 
			{
			  if (tx==0) { /* sound(ptr_.nt[0]); */ } 
			  else 
			    {
			      current[0]++;if (current[0]==41) current[0]=1;
			      /* sound(ptr_.nt[0]*mix[current[0]-1]); */
			    }
			  /*    delay(3); */
			  y+=3;
			} 
		      else 
			{ /*     nosound();delay(3); */ y+=3; }
		    } 
		  else if (present[0]>sample[5][0].nt[0]-St_Start) 
		         {
			   if (y-ms[j]>=tmp[sample[j+8][0].nt[0]-1][present[j]+
								1].act) 
			     {
			       if (y>=cut) y=0;present[j]++;
			       if (present[j]>=
				   tmp[sample[j+8][0].nt[0]-1][0].note)
				 present[j]=1;
			       if (tmp[sample[j+8][0].nt[0]-1][present[j]+
							      1].note==0) 
				 { on[j][1]=0;if (Signal !=1) Square(j,0); } 
			       else { on[j][1]=1;if (Signal != 1) Square(j,1); }
			       ms[j]=y;
			     }
			   if (on[j][1]) 
			     {
			       do {
				    current[j]++;
			  /* sound(uniset[sample[j+8][0].act][current[j]-1]); */
				    /* delay(1); */
				  } while (current[j] != 11);
			       current[j]=1;y+= 10;on[j][1]=0;
			     } 
			   else { /*   nosound(); */ }
			 }
		  /*P*/
		}
	      else if (!(on[0][0] || on[1][0] || on[2][0] || on[3][0] ||
			 on[4][0] || on[5][0] || on[6][0])) 
		     { /*   nosound(); */ }
	    }  /*for*/
	}
      /*    nosound();delay(1600); */
      if (Signal==-1) 
	{
	  XSetFunction(display,gc,GXcopy);
	  for (w=1; w<=3; w++) 
	    {
	      switch (w) 
		{
	          case 1:XPutImage(display,win,gc,pic[0][0],0,0,d_t[0]*2+560,
				   240,322,480);
		         d_t[0]=0;
		    break;
		  case 2:XPutImage(display,win,gc,pic[1][0],0,0,d_t[1]+480,504,
				   160,240);
		         d_t[1]=0;
		    break;
		  case 3:XPutImage(display,win,gc,pic[1][0],0,0,d_t[2]+800,504,
				   160,240);
		         d_t[2]=0;
		    break;
		}
	    }
	}
    }
_LU:if (Signal==-1) 
      {
	free(*pic[0]);free(*pic[1]);
	for (i=0;i<=1;i++) for (j=1;j<=32;j++) free(pic[i][j]);
      }
  if (Signal != 1) { for (w=0;w<=6;w++) Square(w,0); } Signal=0;
  /*else*/
}  /*Sing*/

void Dance()
{
  Signal=-1;Sing(M_Id);
}

int Count(k,ad_pg,n,At_high)
  int k,ad_pg,*n,At_high;
{
  int p,z,kp,fine;

  z=fine=M_Bar_Num=0;if (now>0) p=St_Start;else p=3;
  if ((now>0 && ad_pg>7) || (now==0 && ad_pg>5))
    {
      if (now>0) 
        {
          do {
	       kp=p-22;*n=z;if (z==0) M_Bar_Num++;
	       if (abs(St[k][p][At_high].act)>0) z+=abs(St[k][p][At_high].act);
	       if (z>=sum) z=0;
	       if (!fine && St[k][5][At_high].nt[0]==p) { *n=0;z=0;fine=1; }
	       if (!five && abs(St[k][p][At_high].act)>24) 
		 {
		   switch (abs(St[k][p][At_high].act)) 
		     {
		       case 32:x++;break;
		       case 48:x+=2;break;
		       case 64:x+=3;break;
		     }
		 }
	       p++;
	     } while (kp<ad_pg);
	} 
      else 
	{
	  do {
	       kp=p+3;*n=z;if (tmp[k][p].act>0) z+=tmp[k][p].act;
	       if (z>=sum) { M_Bar_Num++;z=0; }
	       if (!five && tmp[k][p].act>24) 
		 {
		   switch (abs(tmp[k][p].act)) 
		     {
		       case 32:x++;break;
		       case 48:x+=2;break;
		       case 64:x+=3;break;
		     }
		 }
	       p++;
	     } while (kp<ad_pg);
	}
      return (p-1);
    } 
  else if (now==0) return 3;else return St_Start-1;
}

void Showpage(k,PG,P_PG,dum,Num_A,Num_Z)
  int k,PG,P_PG,dum,Num_A,Num_Z;
{
  int addup,once,i,pg,p_pg,p_st,n,x,y,z,kx,ky,finish,FORLIM,At_high;

  if (Debug==20) Display_Array(k,0,40,now);

  if (now>0) sum=St[k][1][1].nt[0]*64/St[k][2][1].nt[0];
  else { sum=tmp_buf[k][1].note*64/tmp_buf[k][1].act;Num_A=2;Num_Z=1; }

  for (At_high=Num_A;At_high>Num_Z;At_high--)
    {
      pg=PG;p_pg=P_PG;n=0;p_st=Count(k,pg*60+p_pg,&n,At_high);finish=0;
      if (now==0)
	{ 
	  if (Motion==Output_On || Motion==Tempo_Set_On || Motion==Print_On) 
	    z=(k%10)*67-26;
	  else z=0;
	  if (p_st>tmp_buf[k][0].note) finish=1;
	}
      else if (p_st>St[k][0][At_high].nt[0]) finish=1;
      if (p_pg==1 && At_high==2) 
	{
	  SetColor("magenta");DrawRectangle(547,1,38,27);
	  Rub(549,3,35,24,"DodgerBlue");SetColor("white");Use_Font("12x24");
	  Out_I_XY(561,25,pg);SetColor("gold");
	  if (pg==0)
	    {
	      OutTextXY(600,26,Race);i=now*1000+k;
	      if (now>0) 
		{
		  Rub(67,3,477,25,"MediumBlue");   /*  Name     */
		  Rub(820,3,40,25,"MediumBlue");   /*  Timbre   */
		  Rub(940,3,40,25,"MediumBlue");   /*  Speed    */
		  Rub(1084,3,40,25,"MediumBlue");  /*  Percent  */
		  Rub(15,V_Ht+7,17,25,"NavyBlue");  /*  Timer  */
		  Rub(15,V_Ht+38,17,25,"NavyBlue");  /* Measure */
		  Rub(15,Dist+135,17,25,"NavyBlue");  /*  Timer  */
		  Rub(15,Dist+166,17,25,"NavyBlue");  /* Measure */
		  SetColor("gold");OutTextXY(67,26,names[i]);
		  Out_I_XY(820,26,St[k][7][1].nt[0]);
		  Out_I_XY(940,26,St[k][3][1].nt[0]);
		  Out_I_XY(1084,26,St[k][4][1].nt[0]);SetColor("green");
		  Out_I_XY(17,V_Ht+29,St[k][1][1].nt[0]);
		  Line(12,V_Ht+34,35,V_Ht+34);
		  Out_I_XY(17,V_Ht+60,St[k][2][1].nt[0]);
		  Out_I_XY(17,Dist+157,St[k][1][1].nt[0]);
		  Line(12,Dist+162,35,Dist+162);
		  Out_I_XY(17,Dist+188,St[k][2][1].nt[0]);
		} 
	      else 
		{
		  Rub(22,73+z,17,25,"NavyBlue");Rub(22,103+z,17,25,"NavyBlue");
		  Rub(47,87+z,160,25,"NavyBlue");SetColor("yellow");
		  if (Motion==Tempo_Set_On) 
		    {
		      if (k==0)
			{
			  OutTextXY(80,26,"Set -->");
			  Rub(180,3,60,25,"MediumBlue");SetColor("magenta");
			  Out_I_XY(180,26,Set_Id+1);SetColor("yellow");
			}
		    }
		  else 
		    { 
		      OutTextXY(80,26,"Tempo -->");
		      Rub(200,3,50,25,"MediumBlue");SetColor("gold");
		      Out_I_XY(200,26,k+1);
		    }
		  Out_I_XY(22,95+z,tmp_buf[k][1].note);Line(17,100+z,40,100+z);
		  Out_I_XY(22,125+z,tmp_buf[k][1].act);SetColor("SpringGreen");
		  if (Motion==Output_On) 
		    OutTextXY(47,110+z,Sub_Str(Sample_names[k],0,13));
		  SetColor("white");Line(206,100+z,221,100+z);
		}
	    }
	  if (now==0) p_pg=6;else if (At_high==2) Tableout(k);
	}
      step=0;

      while ((now>0 && p_pg<61) || (now==0 && p_pg<30))
	{
	  if (p_pg<8 && pg==0 && now>0) 
	    {
	      if (five) 
		{
		  p_pg=1;kx=15;   /*  draw #  */
		  while (p_pg<8) 
		    {
		      x=p_pg;Blank(x,0,At_high);
		      if (St[k][6][At_high].nt[0]!=0)
			{
			  switch (x)
			    {
			      case 1:y=St[k][St_Start-3][At_high].nt[1];break;
			      case 2:y=St[k][St_Start-2][At_high].nt[1];break;
			      case 3:y=St[k][St_Start-2][At_high].nt[2];break;
			      case 4:y=St[k][St_Start-2][At_high].nt[3];break;
			      case 5:y=St[k][St_Start-1][At_high].nt[1];break;
			      case 6:y=St[k][St_Start-1][At_high].nt[2];break;
			      case 7:y=St[k][St_Start-1][At_high].nt[3];break;
			    }
			  ky=(1-St[k][6][At_high].nt[0])/2;
			  if (0<y && y<130) 
			    Draw_Note(kx,ky,0,x,y,1,1,1,At_high);
			}
		      p_pg++;
		    }
		} 
	      else 
		{
		  z=0;for (x=1;x<=7;x++) Blank(x,z,At_high);
		  for (y=0;y<=8;y++) z+=St[k][y][1].act;step=z;
		  if (z>=0) ky=0;else ky=1;if (z==0) kx=7;else kx=abs(z)-1;
		  SetColor("yellow");OutTextXY(20,81,"1=  ");
		  /*
		    pure=XGetImage(display,win,kx*40+52,ky*14+740,26,37,8,
		    ZPixmap);
		    XPutImage(display,win,gc,pure,0,0,77L,34,26,37);p_pg=8;
		  */
		}
	      p_st=St_Start;
	    }
	  if (now>0) z=((p_pg-1)/30)*Dist;
	  switch (p_pg)
	    {
	      case 30:
	      case 60:x=30;break;
	      default:x=p_pg%30;break;
	    }
	  Blank(x,z,At_high);
	  if (!finish && ((now==0 && tmp_buf[k][p_st].note != 200) || (now>0 && 
			  St[k][p_st][At_high].nt[0] != 200)))
	    {
	      if (now==0) { nt=71;at=tmp_buf[k][p_st].act; }
	      else 
		{ nt=St[k][p_st][At_high].nt[0];at=St[k][p_st][At_high].act; }
	      if (nt!=600) Display_Note(k,p_st,z,x,step,At_high);
	      p_st++;n+=abs(at);

	      if (!five) 
		{
		  switch (abs(at)) 
		    {
		      case 2:Underline(x,z,3);break;
		      case 3:Underline(x,z,3);Dot(x*36+17,z+39);break;
		      case 4:Underline(x,z,2);break;
		      case 6:Underline(x,z,2);Dot(x*36+17,z+39);break;
		      case 8:Underline(x,z,1);break;
		      case 12:Underline(x,z,1);Dot(x*36+17,z+39);break;
		      case 24:Dot(x*36+17,z+39);break;
		      case 32:
		      case 48:
		      case 64:FORLIM=(abs(at)-16)/16;
		              for (y=1;y<=FORLIM;y++) 
				{
				  if (x<30)x++;
				  else if (((way+1) % 3)==0) return;
			               else { x=1;way++; }
				  p_pg++;z=((p_pg-1)/30)*Dist;
				  if (p_pg<61) 
				    { Blank(x,z,At_high);Underline(x,z-6,1); }
				}
			break;
		      }
		}
	      if (p_pg<61) 
		{
		  if (n>=sum || (now>0 && (St[k][5][At_high].nt[0]==p_st-1 || 
					   St[k][p_st][At_high].nt[0]==200)) 
		      || (now==0 && (tmp_buf[k][0].act==p_st || 
				     tmp_buf[k][p_st].note==200)))
		    {
		      switch (p_pg) 
			{
			  case 30:
			  case 60:x=30;break;
			  default:x=p_pg % 30;break;
			}
		      if ((now==0 && tmp_buf[k][p_st].note==200) || (now>0 && 
			  St[k][p_st][At_high].nt[0]==200))
			{ 
			  for (y=0; y<2; y++) Line_Sector(x,y*4,z,At_high);
			  finish=1;
			} 
		      else { Line_Sector(x,0,z,At_high);n=0; }
		      if (at<0) 
			{
			  addup=St_Start;once=0;
			  do {
			       if (St[k][addup][At_high].act<0) once=1-once;
			       addup++;
			     } while (addup != p_st);
			  Repeat_Sector(x+1,z,1-once,At_high);
			}
		      if (now>0 && St[k][p_st][At_high].act<0)
			{
			  addup=St_Start;once=0;
			  do {
			       if (St[k][addup][At_high].act<0) once=1-once;
			       addup++;
			     } while (addup != p_st);
			  Repeat_Sector(x+1,z,once,At_high);
			}
		    }
		}
	    }
	  p_pg++;
	}  /*while*/

      if (now==0 && p_pg==30 && !finish) 
	for (y=0;y<2;y++) Line_Sector(x,y*4,z,2);
    }

  if (now>0)
    {                             /* Clear words */
      for (i=0;i<2;i++) Rub(47,i*Dist+148,47+7*150,13,"NavyBlue");
      if (pg==0 && Motion!=Input_On) New_Word=Get_Word_Id();
/*
      if (Debug==20)
	for (i=0;i<Word_Num;i++) 
	  printf("New_Word=%i  Words[%i]=%s\n",New_Word,i,Words[i]);
*/

      if (New_Word!=-1)
	{
	  if (strlen(Words[New_Word])>0) 
	    { Use_Font("7x14");Show_Word(New_Word,pg); }
	}
    }
}  /*Showpage*/ 

void Save_To_Midi(filename,k)
  char *filename;
  int k;
{
  char *midi_name,Pair[10];
  int i,note,Num,Start_repeat,End_repeat;

  midi_name=(char *)malloc(60);*midi_name='\0';Start_repeat=0;End_repeat=0;
  sprintf(midi_name+strlen(midi_name),"%s","Dir_Midi/");
  sprintf(midi_name+strlen(midi_name),"%s",Sub_Str(filename,6,26));
  S_bf=(char *)malloc(10);*S_bf='\0';
  if (now==0) 
    { sprintf(S_bf,"%i",k+1);sprintf(midi_name+strlen(midi_name),"%s",S_bf); }
  sprintf(midi_name+strlen(midi_name)-1,"%s",".midi");
  if ((midifile=fopen(midi_name,"w"))!=NULL) setvbuf(midifile,buf,_IOFBF,2048);
  if (midifile != NULL) rewind(midifile);else midifile=tmpfile();
  if (now==0)
    {
      i=3;
      do {
	   *Pair='\0';note=tmp[k][i].note;
	   if (note!=600)
	     {
	       sprintf(S_bf,"%-3i ",note);
	       strcat(Pair,S_bf);sprintf(S_bf,"%-3i",2*tmp[k][i].act);
	       strcat(Pair,S_bf);fprintf(midifile,"%s\n",Pair);
	     }
	   i++;
	 } while (tmp[k][i].note != 200);
    }
  else
    {
      i=St_Start;
      do {
	   note=St[k][i][1].nt[0];
	   if (note!=600)
	     {
	       *Pair='\0';sprintf(S_bf,"%-3i ",note);strcat(Pair,S_bf);
	       if (St[k][i][1].act>0) sprintf(S_bf,"%-3i",2*St[k][i][1].act);
	       else
		 {
		   if (Start_repeat==0) Start_repeat=i;else End_repeat=i; 
		   sprintf(S_bf,"%-3i",-2*St[k][i][1].act);
		 }
	       strcat(Pair,S_bf);fprintf(midifile,"%s\n",Pair);

	       if (End_repeat!=0)
		 {
		   for (Num=Start_repeat;Num<=End_repeat;Num++)
		     {
		       note=St[k][Num][1].nt[0];
		       if (note!=600)
			 {
			   *Pair='\0';sprintf(S_bf,"%-3i ",note);
			   strcat(Pair,S_bf);
			   sprintf(S_bf,"%-3i",abs(2*St[k][Num][1].act));
			   strcat(Pair,S_bf);fprintf(midifile,"%s\n",Pair);
			 }
		     }
		   Start_repeat=0;End_repeat=0;
		 }
	     }
	   i++;
	 } while (St[k][i][1].nt[0] != 200);
    }

  for (i=0;i<3;i++)
    {
      *Pair='\0';sprintf(S_bf,"%-3i ",-1);strcat(Pair,S_bf);
      sprintf(S_bf,"%-3i",-1);strcat(Pair,S_bf);fprintf(midifile,"%s\n",Pair);
    }

  if (midifile != NULL) fclose(midifile);filvar=NULL;
}

int Load_From_Midi(filename,k)
  char *filename;
  int k;
{
  int i,New_Id,note,act,Pos;
  char Pair[10];

  if (content[now]>999 || (midifile=fopen(filename,"r"))==NULL) return k;
  New_Id=content[now];tail=content[now]+1;S_bf=(char *)malloc(10);*S_bf='\0';
  Clear_Array(New_Id,now);
  if (now==0)
    {
      for (i=0;i<30;i++) 
	{ 
	  tmp[New_Id][i].note=0;tmp[New_Id][i].act=0;
	}
      tmp[New_Id][1].note=4;       /*    Timer     */
      tmp[New_Id][1].act=4;        /*    Measure    */
      setvbuf(midifile,buf,_IOFBF,2048);rewind(midifile);Pos=3;
      do {
	   fgets(Pair,10,midifile);note=atoi(strncpy(S_bf,Pair,3));
	   strncpy(S_bf,Pair+3,1);act=atoi(strncpy(S_bf,Pair+4,3));
	   tmp[New_Id][Pos].note=note;tmp[New_Id][Pos++].act=act/2;
	 } while (note != -1);

      tmp[New_Id][Pos-1].note=200;tmp[New_Id][Pos-1].act=0;
      tmp[New_Id][0].note=Pos-1;

      do { tmp[New_Id][Pos].note=200;tmp[New_Id][Pos++].act=0; } while (Pos<29);
    }
  else 
    {
      Pos=St_Start;i=now*1000+New_Id;
      sprintf(S_bf,"%5ld",i+1);strcpy(names[i],S_bf);ch='.';
      sprintf(names[i]+strlen(names[i]),"%c",ch);
      sprintf(names[i]+strlen(names[i]),"%s",Sub_Str(filename,9,
						     strlen(filename)-14));
      sprintf(names[i]+strlen(names[i]),"%c",'\n');Clear_Array(New_Id,now);

      St[New_Id][1][0].nt[0]=4;    /*    Timer     */
      St[New_Id][1][1].nt[0]=4;
      St[New_Id][1][2].nt[0]=4;
      St[New_Id][2][0].nt[0]=4;    /*    Measure   */
      St[New_Id][2][1].nt[0]=4;
      St[New_Id][2][2].nt[0]=4;
      St[New_Id][3][0].nt[0]=76;   /*    Speed     */
      St[New_Id][3][1].nt[0]=76;
      St[New_Id][3][2].nt[0]=76;
      St[New_Id][4][0].nt[0]=70;   /*    Percent   */
      St[New_Id][4][1].nt[0]=70;
      St[New_Id][4][2].nt[0]=70;
      St[New_Id][7][0].nt[0]=0;    /*    Timbre    */
      St[New_Id][7][1].nt[0]=0;
      St[New_Id][7][2].nt[0]=0;

      setvbuf(midifile,buf,_IOFBF,2048);rewind(midifile);
      do {
	   fgets(Pair,10,midifile);note=atoi(strncpy(S_bf,Pair,4));
	   act=atoi(strncpy(S_bf,Pair+4,4));St[New_Id][Pos][1].nt[0]=note;
	   St[New_Id][Pos++][1].act=act/2;
	 } while (note != -1);
                               /*  page #  */
      St[New_Id][0][1].nt[0]=Pos-1;St[New_Id][Pos-1][1].nt[0]=200;
      St[New_Id][Pos-1][1].nt[1]=0;St[New_Id][Pos-1][1].nt[2]=0;
      St[New_Id][Pos-1][1].nt[3]=0;St[New_Id][8][1].nt[0]=(Pos-St_Start+7)/60;
    }

  if (midifile != NULL) fclose(midifile);midifile= NULL;
  head=New_Id+1;tail=content[now]+1;Save(New_Id+1,tail);
  return (content[now]-1);
}

void Save_To_Back_Up(filename,k)
  char *filename;
  int k;
{
  char *Text_name,Line[100],C_Dot[2];
  int i,j,At_high,note,Zero;

  Text_name=(char *)malloc(60);*Text_name='\0';*Line='\0';Zero=0;
  sprintf(Text_name+strlen(Text_name),"%s","Dir_Text/");*C_Dot='\0';
  sprintf(C_Dot,"%s",Sub_Str(filename,strlen(filename)-6,1));
  if (C_Dot==".") 
    sprintf(Text_name+strlen(Text_name),"%s",Sub_Str(filename,6,
						     strlen(filename)-11));
  else sprintf(Text_name+strlen(Text_name),"%s",Sub_Str(filename,6,26));
  S_bf=(char *)malloc(10);*S_bf='\0';
  if (now==0) 
    { sprintf(S_bf,"%i",k+1);sprintf(Text_name+strlen(Text_name),"%s",S_bf); }
  sprintf(Text_name+strlen(Text_name)-1,"%s",".text");
  if ((Textfile=fopen(Text_name,"w"))!=NULL)
    { setvbuf(Textfile,buf,_IOFBF,2048);rewind(Textfile); }
  else Textfile=tmpfile();

  if (now>0)
    for (i=0;i<Word_Num;i++) 
      if (Words_Array[i]==now*1000+k+1 && strlen(Words[i])>=5) 
	{ 
	  sprintf(S_bf,"%4ld",1);strcat(Line,S_bf);
          fprintf(Textfile,"%s\n",Line);
          fprintf(Textfile,"%s\n",Words[i]);Zero=1;break;
	}
  if (Zero==0)
    { 
      sprintf(S_bf,"%4ld",0);strcat(Line,S_bf);fprintf(Textfile,"%s\n\n",Line);
    }

  i=0;
  if (now==0)
    {
      do {
	   *Line='\0';note=tmp[k][i].note;sprintf(S_bf,"%4ld",note);
	   strcat(Line,S_bf);sprintf(S_bf,"%4ld",tmp[k][i].act);
           strcat(Line,S_bf);fprintf(Textfile,"%s\n",Line);i++;
	 } while (tmp[k][i-1].note!=200 && i<30);
    }
  else
    {
      do {
	   *Line='\0';
	   for (At_high=0;At_high<3;At_high++)
	     {
	       for (j=0;j<4;j++)
		 { 
		   note=St[k][i][At_high].nt[j];sprintf(S_bf,"%4ld",note);
		   strcat(Line,S_bf);
		 }
	       sprintf(S_bf,"%4ld",St[k][i][At_high].act);strcat(Line,S_bf);
	       sprintf(S_bf,"%4ld",St[k][i][At_high].vol);strcat(Line,S_bf);
	     }
	   fprintf(Textfile,"%s\n",Line);i++;
	 } while ((St[k][i-1][0].nt[0]!=200 || St[k][i-1][1].nt[0]!=200 || 
		   St[k][i-1][2].nt[0]!=200) && i<M_Len);
    }
  if (Textfile != NULL) fclose(Textfile);Textfile=NULL;
}

int Load_From_Back_Up(filename,k,Single)
  char *filename;
  int k,Single;
{
  int i,j,New_Id,note,act,Zero;
  char Line[100],*Word_Buf;

  if (content[now]>999 || (Textfile=fopen(filename,"r"))==NULL)
    { if (Single==1) return k;else return -1; }
  New_Id=content[now];tail=content[now]+1;S_bf=(char *)malloc(10);*S_bf='\0';

  i=now*1000+New_Id;sprintf(S_bf,"%5ld",i+1);strcpy(names[i],S_bf);ch='.';
  sprintf(names[i]+strlen(names[i]),"%c",ch);
  sprintf(names[i]+strlen(names[i]),"%s",Sub_Str(filename,9,
						 strlen(filename)-14));
  sprintf(names[i]+strlen(names[i]),"%c",'\n');

  if (now==0)
    {
      Clear_Array(New_Id,now);setvbuf(Textfile,buf,_IOFBF,2048);
      rewind(Textfile);i=0;fgets(Line,100,Textfile);
      Zero=atoi(strncpy(S_bf,Line,4));if (Zero!=0) return k;
      do {
	   fgets(Line,100,Textfile);S_bf=(char *)malloc(10);*S_bf='\0';
	   note=atoi(strncpy(S_bf,Line,4));act=atoi(strncpy(S_bf,Line+4,4));
	   tmp[New_Id][i].note=note;tmp[New_Id][i++].act=act;
	 } while (note != 200 && i<30);
    }
  else
    {
      Clear_Array(New_Id,now);setvbuf(Textfile,buf,_IOFBF,2048);
      rewind(Textfile);S_bf=(char *)malloc(10);*S_bf='\0';
      fgets(Line,100,Textfile);Zero=atoi(strncpy(S_bf,Line,4));i=0;
      if (Zero==1) 
	{
          Word_Num=abs(Word_Num);Words[Word_Num]=(char *)malloc(4500);
          *Words[Word_Num]='\0';Word_Buf=(char *)malloc(4500);*Word_Buf='\0';
	  fgets(Word_Buf,4500,Textfile);
	  sprintf(Words[Word_Num],"%s",Sub_Str(Word_Buf,0,strlen(Word_Buf)-1));
	  Words_Array[Word_Num++]=now*1000+New_Id+1;Word_Num=-Word_Num;
	}
      else fgets(Line,100,Textfile);
      do {
	   fgets(Line,100,Textfile);S_bf=(char *)malloc(10);*S_bf='\0';

	   for (j=0;j<4;j++) 
	     St[New_Id][i][0].nt[j]=atoi(strncpy(S_bf,Line+4*j,4));
	   St[New_Id][i][0].act=atoi(strncpy(S_bf,Line+4*4,4));
	   St[New_Id][i][0].vol=atoi(strncpy(S_bf,Line+4*5,4));

	   for (j=6;j<10;j++) 
	     St[New_Id][i][1].nt[j-6]=atoi(strncpy(S_bf,Line+4*j,4));
	   St[New_Id][i][1].act=atoi(strncpy(S_bf,Line+4*10,4));
	   St[New_Id][i][1].vol=atoi(strncpy(S_bf,Line+4*11,4));
	   for (j=12;j<16;j++)
	     St[New_Id][i][2].nt[j-12]=atoi(strncpy(S_bf,Line+4*j,4));
	   St[New_Id][i][2].act=atoi(strncpy(S_bf,Line+4*16,4));
	   St[New_Id][i++][2].vol=atoi(strncpy(S_bf,Line+4*17,4));
	 } while ((St[New_Id][i-1][0].nt[0]!=200||St[New_Id][i-1][1].nt[0]!=200
		   || St[New_Id][i-1][2].nt[0]!=200) && i<M_Len-1);
    }
  if (Textfile != NULL) fclose(Textfile);Textfile= NULL;
  head=New_Id+1;tail=content[now]+1;
  if (Single==1) { Save(New_Id+1,tail);M_Id=New_Id; } else content[now]+=1;
  return (content[now]-1);
}

void Show_host(IN)
  int IN;
{
  Host=1;In_Menu=0;
  if (Old_Motion==List_On) { Show_Preface(139);Action=List_On;Motion=0; }
  switch(IN)
    {
      case 0:Motion=-Input_On;;break;
      case 2:Motion=-Output_On;break;
      case 9:unite=1;Motion=-Output_On;break;
      case 13:Motion=-Tempo_Set_On;break;
      case 21:Motion=-Print_On;break;
    }
}

void Finish_host()
{
  int Melody_Id;

  Race=(char *)malloc(30);*Race='\0';SetColor("gold");Melody_Id=-1;
  if (Column_Id>0) next=Column_Id-1;else next=Host_X*6+Host_Y;
  if (next==Max_kind-1 && Motion!=-Print_On && Motion!=-Output_On) 
    Motion=-Tempo_Set_On;

  if (0<=Row_Id && Row_Id<content[Column_Id-1]) Melody_Id=Row_Id;
  else 
    {
      if (Motion==-Input_On && Column_Id>0) Melody_Id=content[Column_Id-1];
      else if (Motion==-Output_On)
	     Melody_Id=0;
           else if (Motion==-Print_On) Melody_Id=-1;
                else if (Motion==-Tempo_Set_On) Melody_Id=0;
    }
  sprintf(Race+strlen(Race),"%s",Get_Filename(next,0));Host=0;
  switch (Motion)
    {
      case -Input_On:Motion=Input_On;Input(Melody_Id);Get_List();break;
      case -Output_On:if (next<Max_kind-1) 
	                { Motion=Output_On;Output(Melody_Id); }
	              else { Motion=Tempo_Set_On;See_Tempo_Set(Melody_Id); }
	break;
      case -Tempo_Set_On:Motion=Tempo_Set_On;Combine_Tempo(Melody_Id);break;
      case -Print_On:if (next!=Max_kind-1)
	               { Motion=Print_On;Print_Melody(Melody_Id); }
	             else 
		       { 
			 Action=Print_On;Motion=Tempo_Set_On;
			 if (Melody_Id==-1) Melody_Id=0;
			 See_Tempo_Set(Melody_Id);
		       }
	break;
/*      case -Sing_On:Motion=Sing_On;Sing();break;     */
    }
  RefreshMenu();
}

void Update_Text_Tar()
{
  char f_head[100],fn[100],Suffix[10];
  struct stat statbuf;
  int rv_stat,Len,i,Num;
  struct dirent *dirbuf;
  DIR *dir;

  for (now=1;now<Max_kind-1;now++)
    {
      Num=content[now];
      if (Num>0)
	{ Load();for (i=0;i<Num;i++) Save_To_Back_Up(names[now*1000+i],i); }
    }

  strcpy(f_head,"Dir_Text");rv_stat=stat(f_head,&statbuf);
  if (!S_ISDIR(statbuf.st_mode))
    { printf("%s is not a directory\n",f_head);return; }

  if ((dir=opendir(f_head))==NULL)
    { printf("failed to open %s\n",f_head);return; }

  if ((filvar=fopen("Dir_Names/IM_Update","w"))!=NULL) 
    { setvbuf(filvar,buf,_IOFBF,2048);rewind(filvar); }
  else filvar=tmpfile();

  while ((dirbuf=readdir(dir))!=NULL)
    {
      Len=strlen(dirbuf->d_name);strcpy(Suffix,Sub_Str(dirbuf->d_name,Len-5,5));
      if (strcmp(".text",Suffix)==0)
	{ sprintf(fn,"%s",dirbuf->d_name);fprintf(filvar,"%s\n",fn); }
     }
  closedir(dir);if (filvar != NULL) fclose(filvar);filvar=NULL;
  system("tar cf Dir_Text.tar Dir_Text");system("compress Dir_Text.tar");
  system("mv Dir_Text.tar.Z Dir_NM_Bank");
}

