/*                             =====  tts.h  ===== 
*/

/*
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/keysym.h>
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

/* Some global Xlib variables used in all files: */

#define Sign(A) ((A) > 0 ? 1.0 : ( (A) < 0 ? -1.0 : 0.0))
#define Max(A,B) ((A) >= (B) ? (A) : (B))
#define Min(A,B) ((A) <= (B) ? (A) : (B))

#define St_Start  30
#define M_Len     630

typedef struct Chord 
{
  int nt[4],act,vol;
} Chord;

typedef struct Tempo_Unit 
{
  int note,act;
} Tempo_Unit;

typedef struct contmp 
{
  char Set_name[50];
  int tempo[6],instru[6];
} Tempo_Set;

Chord St[M_Len][3];
Tempo_Unit tmp[1000][30],tmp_buf[1000][30];

int Key,Duration,Time,Measure,Percent,sum,V_Ht,Appear[120];

double freq,speed;

char *S_bf,buf[2048];

FILE *Textfile;

/*     Finish :  Note = 200    */
